﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// MonoBehaviourista periytymisen sijasta laitetaan tämä skripti periytymään Kuoleminen-skriptistä.
public class RobotinKuoleminen : Kuoleminen {

    // Robotin elämäpisteet palautuvat hiljalleen, joten tarvitsemme Update-funktiota.
	void Update () {
        //Lisätään Elämäpisteet-aksessorin kautta niitä lisää deltaTimen verran joka Update-funktion kutsulla.
        Elämäpisteet += Time.deltaTime;
	}

    // Periytyminen Kuoleminen-skriptistä vaatii tämän skriptin täyttämään sen julistaman Kuole-funktion.
    // Näkyvyys pysyy suojattuna, mutta abstrakti sanan tilalle kirjoitetaan override, eli päällekirjoitetaan
    // perityn skriptin funktio.
    protected override void Kuole()
    {
        // Piilotetaan objekti maailmasta laittamalla se inaktiiviseksi.
        gameObject.SetActive(false);

        // Pysäytetään peli asettamalla Time-luokan timeScale-arvoksi nolla
        // Tätä arvoa muuttamalla voi peliin myös saada hidastuksia ja nopeutuksia.
        Time.timeScale = 0f;

        // Kirjoitetaan teksti konsoliin print-funktiolla. Toinen vaihtoehto on Debug.Log("Pelaaja hävisi!");
        print("Pelaaja hävisi!");
    }

}
